class ExMonsterEnd extends MonsterEnd2;

var() bool bGoodEnding;
var() string SuccessMsg;
var() string FailedMsg;
var() bool bDelayed;
var() int DelayTime;

function PostBeginplay()
{
	bGameRelevant = False;
	//Just spawned, Get Rid of Power if have
	Super.PostBeginPlay();
}

function Trigger (Actor Other, Pawn EventInstigator)
{
	local actor a;

	if (bDelayed)
		GotoState('Waiting');
	else
		TriggerObjective();
}

function TriggerObjective()
{
	local MonsterHunt2 MH;

	if (!Level.Game.bGameEnded)
	{
		MH = MonsterHunt2(Level.Game);
		if (MH != None)
		{
			if (bGoodEnding)
			{
				MH.GameEndedMessage = SuccessMsg;
				MH.EndGame(SuccessMsg);
			}
			else
			{
				MH.TimeOutMessage = FailedMsg;
				MH.TimeLimit = 2;
				MH.RemainingTime = 1;
			}
		}
		else
			log("ExtendedMonsterEnd - TriggerObjective - MH == None");
	}
}

State Waiting
{
	function Trigger (Actor Other, Pawn EventInstigator)
	{
		GotoState('');
	}

Begin:
	Sleep(DelayTime);
	TriggerObjective();
}

defaultproperties
{
     bGoodEnding=True
     SuccessMsg="Hunt Successfull!"
     FailedMsg="Hunt Failed!"
     bCollideWhenPlacing=False
}
