//=============================================================================
// FL_Mutator.
//=============================================================================
class FL_Mutator extends Mutator
	config(MH2_NS_V2);

var config bool bInitiallyOn, bBrightPlayer, bSearchlight;

function PostBeginPlay()
{
	local Pawn P;
	saveconfig();
	Super.PostBeginPlay();
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local Inventory Inv;

	if ( MutateString ~= "Flashlight" )
	{
		if ( (Sender.Health <= 0) || Sender.PlayerReplicationInfo.bIsSpectator )
		return;

		if ( !bSearchLight )
		Inv = Sender.FindInventoryType(class'FL_Flashlight');
		else
		Inv = Sender.FindInventoryType(class'FL_Searchlight');

		if ( Inv != None )
		{
			if ( Inv.bActive )
			{
				Inv.GoToState('DeActivated');
				Inv.bActive = False;
			}
			else
				Inv.GoToState('Activated');
		}
		else
		{
			if ( !bSearchlight )
			Sender.ClientMessage("You have no Flashlight.");
			else
			Sender.ClientMessage("You have no Searchlight.");
		}
		return;
	}
   if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);
}

function ModifyPlayer(Pawn Other)
{
	local Inventory Inv;

	if ( Other.IsA('TournamentPlayer') )
	{
		if ( !bSearchlight )
		{
			Inv = Spawn(class'FL_Flashlight',Other.Owner,Other.Tag,Other.Location,Other.Rotation);
			if ( Inv != None )
			Inv.GiveTo(Other);
			if ( bInitiallyOn )
				Inv.Activate();
		}
		else
		{
			Inv = Spawn(class'FL_Searchlight',Other.Owner,Other.Tag,Other.Location,Other.Rotation);
			if ( Inv != None )
			Inv.GiveTo(Other);
			if ( bInitiallyOn )
				Inv.Activate();
		}
	}
	Super.ModifyPlayer(Other);
}

defaultproperties
{
     bInitiallyOn=True
}
