//=============================================================================
// RingExplosion. MH version
//=============================================================================
class MHRingExplosion extends RingExplosion;

var bool bExtraEffectsSpawned;

simulated function Tick( float DeltaTime )
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		if ( !bExtraEffectsSpawned )
			SpawnExtraEffects();
		ScaleGlow = (Lifespan/Default.Lifespan);
		AmbientGlow = ScaleGlow * 255;		
	}
}

simulated function PostBeginPlay()
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		PlayAnim( 'Explosion', 0.25 );
		SpawnEffects();
	}	
	if ( Instigator != None )
		MakeNoise(0.5);
}

simulated function SpawnEffects()
{
//	Spawn(Class'BotPack.EnergyImpact');
	Super.SpawnEffects();
}

simulated function SpawnExtraEffects()
{
	 Spawn(class'BotPack.EnergyImpact');
	 bExtraEffectsSpawned = True;
}

defaultproperties
{
     ExploSound=Sound'UnrealShare.General.Expl03'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=0.800000
     DrawType=DT_Mesh
     Style=STY_None
     Mesh=LodMesh'UnrealShare.Ringex'
     DrawScale=0.700000
     ScaleGlow=1.100000
     bUnlit=True
}
