// Separate class out of mutator

class TimedBoy extends Actor config (MH2_NS_V2);

replication
{
	reliable if ( Role < ROLE_Authority )
		NewSong;
}

	var (AI) name Tz;
	var bool bUTReplace, bFoundLeader, BotCheck, DecoCheck, bWeaponCrap;
	var float LastMonsterAttackTime, LastMadTime, LastMonsterCountTime, tmr;
	var int AmpCount, kakuCount, HealthCount, NumWeps,
		blockattacktime, healthtimer, RegenAmmo, RegenHealth,
		HealthKillRegen, groundasstime, permitlamastime, lolattacktime,
		ActorTime, ActorCheckTime, listpawn, listpawntime, NumAttackers, NeedAttackers;
	var config int MaxMonsterHealth, AmpTime, kakuTime, HealthTime, HealthRegenPerSec,
		AmmoRegenPerSec, MaxHealth, MaxRegenHealth; 
	var config bool bUseRegenAmmo, bUseRegenHealth, bScaleRegen, bCorrodeFaster;

//	Music related craps
	var music NewSong;

simulated event PostBeginPlay()
{
	lolattacktime = 0;
	groundasstime = 0;
	ActorTime = 0;
	listpawn = 0;
	blockattacktime = 5;
	permitlamastime = 2;
	ActorCheckTime = 2;
	listpawntime = 1;
	RegenHealth = HealthRegenPerSec;
	RegenAmmo = AmmoRegenPerSec;
//	tmr=Level.Game.GameSpeed;
//	log ("Timer is "$tmr);
	bGameRelevant=False; //Now is time to work dynamically
	tmr=Level.TimeDilation;
	log ("Timed Boy Timer is "$tmr);
	Super.PostBeginPlay();
	log ("Timer add-on has been engaged.");
	Tz = MonsterHunt2(Level.Game).TT;
	SaveConfig();
	SetTimer(tmr,True);
	GetMusicControl();
}

simulated function GetMusicControl()
{
	if ( Level.Song != None )
		NewSong = Level.Song;
	else NewSong = Music'null48.null48';
	log ("Song used by TimedBoy is "$NewSong);
}

event Timer()
{
	DoTicking();
//	Super.Timer();
}

function DoTicking()
{
	local Pawn P;
	local ScriptedPawn S, S1;
	local Bot B;
	local Inventory Inv;
	local Queen Q;
	local SkaarjTrooper ST;
	local Weapon Wp, Wp1;
	local TournamentWeapon W;
	local Fragment F;
	local CreatureCarcass C;
	local UTHumanCarcass UH;
	local Mover M;
	local Actor A;
	local nsgrenade ne;
	local Decoration D;
	local TeamCannon T;
	local MHTeamCannon MHT;
	local MHMinigunCannon MHM;
	local Music Mu;

//Work around to see what's wrong
//	log ("TimedBoy timer is ticking...");
//	Checking a few things...
//	log("TimedBoy reporting > Level.bBegunPlay > "@Level.bBegunPlay);
//	log("TimedBoy reporting > Level.bStartup > "@Level.bStartup);
/*	log("TimedBoy reporting > Level.AvgAITime > "@Level.AvgAITime);
	log ("AIProfile0 is "$Level.AIProfile[0]);
	log ("AIProfile1 is "$Level.AIProfile[1]);
	log ("AIProfile2 is "$Level.AIProfile[2]);
	log ("AIProfile3 is "$Level.AIProfile[3]);
	log ("AIProfile4 is "$Level.AIProfile[4]);
	log ("AIProfile5 is "$Level.AIProfile[5]);
	log ("AIProfile6 is "$Level.AIProfile[6]);
	log ("AIProfile7 is "$Level.AIProfile[7]);
*/
/*	log("Timer Sequence started at "$Level.Hour$":"$Level.Minute$":"$Level.Second$":"$Level.Millisecond);
	log("Dilation is: "$Level.TimeDilation);
	log ("GameSpeed set to: "$Level.Game.GameSpeed);
*/
// Partially or totally solved ? Yay !
// I just modified function SetGameSpeed to some value.
// Now timer crawl nearby the same millisecond only with small deviations.
// It looks like sustains more accurate the timer.
// Gotta check more details

//Checks
	if ( MonsterHunt2(Level.Game).bGameEnded ) return;
	NumAttackers = 0;
	ActorTime++;
	if (ActorTime >= ActorCheckTime)
	{
//		log("Actors time");
		ActorTime = 0;
		if (!bFoundLeader)
			AssesLeader();
		if (!BotCheck)
		{
			foreach Level.AllActors (class 'Bot',B)
			{
				if ( B.Weapon == None && !B.bHidden )
				{
//					log ("Found possible player at "$B.Location$" being a "$B$" without weapon, attempt arming pawn...");
					B.bIsPlayer = True;
					Wp = spawn (class 'MH2_NS_V2.MHRifle',,,B.Location);
					Wp.RespawnTime=0;
					Wp.GiveTo(B);
					Wp.bHeldItem = True;
					Wp.SetSwitchPriority(B);
					Wp.WeaponSet(B);
					B.PendingWeapon = None;
					Wp.GiveAmmo(B);
					if (Wp.AmmoType != None)
						Wp.AmmoType.AmmoAmount = Wp.AmmoType.MaxAmmo;
				}
			}
			BotCheck = True;
			foreach AllActors(class 'TeamCannon', T )
			{
				if ( T != None && !T.bStatic && !T.bNoDelete )
				{
					if ( T.class == class 'TeamCannon' )
					{
						T.SetCollision(False,False,False);
						MHT = spawn(class'MHTeamCannon',,,T.Location,T.Rotation);
						if ( MHT != None )
						{
							log (T$" needs to be morphed to "$MHT);
							MHT.MyTeam=T.MyTeam;
							MHT.DrawScale=T.DrawScale;
							MHT.ProjectileType=T.ProjectileType;
							MHT.ActivateSound=T.ActivateSound;
							MHT.DeactivateSound=T.DeactivateSound;
							MHT.FireSound=T.Firesound;
							MHT.PostKillMessage=T.PostKillMessage;
							T.Destroy();
						}
					}
					if ( T.class == class 'MinigunCannon' )
					{
						T.SetCollision(False,False,False);
						MHM = spawn(class'MHMinigunCannon',,,T.Location,T.Rotation);
						if ( MHM != None )
						{
							log (T$" needs to be morphed to "$MHM);
							MHM.MyTeam=T.MyTeam;
							MHM.DrawScale=T.DrawScale;
							MHM.ProjectileType=T.ProjectileType;
							MHM.ActivateSound=T.ActivateSound;
							MHM.DeactivateSound=T.DeactivateSound;
							MHM.FireSound=T.Firesound;
							MHM.PostKillMessage=T.PostKillMessage;
							T.Destroy();
						}
					}
				}
			}
		}

//Assign collision for decorations replaced. Need this !
		if (!DecoCheck)
		{
			foreach AllActors (class 'Decoration', D)
			{
				if (D != None && !D.bBlockActors)
				{
				if ( D.IsA('ExBarrel') || D.IsA('ExVase') || D.IsA('ExWoodenBox') || D.IsA('ExChest') ||
					 D.IsA('ExTarydiumBarrel') || D.IsA('ExChair') || D.IsA('ExMonkStatue') || D.IsA('ExSludgeBarrel')
					 || D.IsA('ExLamp4') || D.IsA('ExUrn') || D.IsA('ExTable')|| D.IsA('ExCannon'))
					D.SetCollision(True,True,True);
				}
			}
			DecoCheck = True;
			ConsoleCommand("obj garbage");
		}

		foreach Level.AllActors (class 'Actor', A)
		{
			if (A.IsA('Fragment')) F = Fragment(A);
			if ( F != None ) F.Destroy();
//			if (A.IsA('Mover')) M = Mover(A);
			if (A.IsA('TournamentWeapon')) W = TournamentWeapon(A);
/*			if ( A.IsA('SpawnPoint') )
			{
				if ( SpawnPoint(A).factory == None )
				{
					SpawnPoint(A).Disable('Trigger');
					SpawnPoint(A).Disable('Touch');
					SpawnPoint(A).SetCollision(False,False,False);
				}
			}
*/
			if ( bCorrodeFaster ) //Is pure crap Carcass.Dead.Timer
			{
				if (A.IsA('UTHumanCarcass')) UH = UTHumanCarcass(A);
				if (A.IsA('CreatureCarcass')) C = CreatureCarcass(A);
				if ( UH != None && (!UH.bStatic && !UH.bNoDelete))
				{
					UH.GotoState('Corroding'); //Cya, Last chance passed away
//					Gotta check how works by spawning a controller or such. Will see another time...
				}
				if ( C != None && (!C.bStatic && !C.bNoDelete) && !C.IsA('ExCreatureCarcass')) C.bCorroding = True;
			}
			if ( W != None && W.bTossedOut )
				W.Destroy();
		}
	}
	listpawn++;
	if (listpawn >= listPawnTime)
	{
//			log ("PawnList timer");
		foreach Level.AllActors(class 'Weapon', Wp)
		{
			if ( Wp != None )
			{
/*				if ( Wp.LifeSpan > 0 && Wp.bHeldItem && Wp.Instigator != None )
				{
					Wp.LifeSpan = Wp.Default.Lifespan;
//					log("A weapon "$Wp$" has now LifeSpan "$Wp.Lifespan$" because has an Instigator "$Wp.Instigator.GetHumanName());
				}
*/
				if ( Wp.Instigator != None && Wp.Instigator.Weapon != Wp && Wp.Instigator.PlayerReplicationInfo == None)
				{
					Wp.SetLocation(Wp.Instigator.Location);
					Wp.Instigator.bIsPlayer = True;
					Wp.Touch(Wp.Instigator);
					if ( Wp.AmmoType != None )
						Wp.AmmoType.AmmoAmount = Wp.AmmoType.Default.AmmoAmount + 5;
					Wp.Instigator.bIsPlayer = False;
				}
			}
		}
		listpawn = 0;
		if (!MonsterHunt2(Level.Game).bStartedHunt) return; //Done. If game isn't started return timer here.
		lolattacktime++;
//		WeaponCount++;
		if (lolattacktime > blockattacktime*2)
			lolattacktime = 0;
//		if (WeaponCount > WeaponCheckTime*2)
//			WeaponCount = 0;
		foreach AllActors(class 'Pawn',P)
//		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		{
			ST = SkaarjTrooper(P);
			S = ScriptedPawn(P);
			B = Bot(P);
			Q = Queen(P);
			if (S != None && S.Health > 0)
			{
			if (!bWeaponCrap)
			{
				foreach AllActors (class 'Weapon', Wp)
				{
					if ( Wp.Instigator != None && Wp.bHeldItem && Wp.Instigator.PlayerReplicationInfo == None )
					{
						P = Wp.Instigator;
						Wp1 = Spawn( Wp.class,P,,P.Location,P.Rotation );
						if (Wp1 != None)
						{
							Wp1.RespawnTime = 0.00;
							P.Weapon = None;
							P.PendingWeapon = None;
							Wp.PickupAmmoCount=0;
							Wp.Destroy();
							Wp1.BecomeItem();
							Wp1.Instigator = P;
							P.AddInventory(Wp1);
							Wp1.GiveAmmo(P);
							Wp1.WeaponSet(P);
							P.BaseEyeHeight = P.CollisionHeight/1.4;
							Wp1.SetHand(1);
//							Wp1.AimError += 50;
							Wp1.FireOffset = Wp1.FireOffset * 2 * P.DrawScale;
							Wp1.FireOffset.X = Wp1.Default.FireOffset.X * (P.DrawScale / P.Default.DrawScale) * 4 * P.DrawScale;
							Wp1.FireOffset.Y = Wp1.Default.FireOffset.Y;
							Wp1.FireOffset.Z = Wp1.Default.FireOffset.Z * P.DrawScale;
						}
					}
				}
				bWeaponCrap = True;
			}
				if ( NumAttackers < NeedAttackers )
				{
					if ( S.Enemy != None && !S.Enemy.IsA('ScriptedPawn') && VSize(S.Velocity) > 50 )
					{
						NumAttackers++;
						foreach S.VisibleCollidingActors (class 'ScriptedPawn',S1, 700) //Trigger other nearby monster properly.
						{
							if ( S1 != None )
							{
								if ( (S1.Enemy == None || (FRand() > 0.7 && S1.Enemy != None && S1.Enemy != S.Enemy ) )
								&& S != S1 && S1.Health >= 1 && NumAttackers <= NeedAttackers
								&& ( S1.IsInstate('Waiting') || S1.IsInState('Wandering') ))
								{
									S1.Hated = S.Hated;
									S1.Enemy = S.Enemy;
									S1.LastSeenPos = S.Enemy.Location;
									S1.GotoState('Attacking');
									NumAttackers++;
								}
								else 
									if (NumAttackers > NeedAttackers) break; //preserve safe break if reached to desired number of attackers
							}
						}
					}
				}
				if (S.numHuntPaths > 5)
	//				S.numHuntPaths--;
					S.NumHuntPaths = 5;
				if (S.Mesh == None)
					S.Mesh = S.default.mesh;
				if (!S.bIsBoss && S.health >= 4000)
					S.bIsBoss = True;
				if (S.ReducedDamagePct > 0)
				{
					S.ReducedDamageType = '';
					S.ReducedDamagePct = 0;
				}
				if (lolattacktime >= blockattacktime)
				{
	//				BroadcastMessage("Target check...");
					if ( S.Enemy != None && !FastTrace(S.Location,S.Enemy.Location) && S.IsInState('RangedAttack'))
					{
						S.Target = S;
						S.bHunting = False;
						S.GotoState('Wandering');
					}
					if (S.Enemy != None && S.Target != S.Enemy && S.CanSee(S.Enemy) && S.IsInState('RangedAttack'))
					{
						S.Target = S.Enemy;
						S.NeedToTurn(S.Enemy.Location);
					}
					if ( S != None && S.bTeamLeader && S.bHidden && !S.IsInState('GameEnded'))
					{
						S.Enemy = None;
						S.Hated = None;
						S.Target = None;
						S.bHunting = False;
						S.GotoState('GameEnded'); //If case of bringing back to life
					}
					lolattacktime = 0;
				}
			}
			if (Q != None)
			{
				if (Q.IsInState('Teleporting'))
					Q.GoToState('Roaming','');
				}
			if (ST != None && ST.Inventory == None)
			{
/*				if (ST.MyWeapon != None && ST.Weapon == None)
				{
					ST.MyWeapon.GiveTo(ST);
					ST.Weapon=ST.MyWeapon;
					ST.PendingWeapon(ST.Weapon);
					ST.ChangedWeapon();
				}
				else
*/
					if ( ST.Weapon == None && ST.WeaponType == None )
					Wp = spawn (class 'MH2_NS_V2.MHAsmd',ST,,ST.Location);
					if ( Wp != None )
					{
						Wp.RespawnTime=0.00;
						if (!ST.bIsPlayer)
							ST.bIsPlayer = True;
						Wp.Touch(ST);
//						Wp.BringUp();
					}
				ST.bIsPlayer = False;
			}

			if ( S != None && S.Inventory != None && S.Health > 0 ) //if another kinda crappy creature is armed and forgot in bIsPlayer mode
				S.bIsPlayer = False;

			if ( B != None )
			{
				if (B.MoveTarget != None)
					if ( B.IsInState('FallingState') && B.MoveTarget.IsA('Pathnode') )
					{
						B.MoveTimer = -1.0;
						B.MoveTarget = None;
					}
			}

//		if ( P.IsA('ScriptedPawn') || P.IsA('FlockPawn') || P.IsA('FlockMasterPawn') || P.IsA('StationaryPawn')) continue;
			if (bScaleRegen)
			{
			if ( P.IsA('Bot') || P.IsA('TournamentPlayer') )
				if ( P.Health > 0 )
				{
					if ( Bot(P) != None && Bot(P).Health > 1 && Bot(P).Region.Zone.bWaterZone )
					{
						if ( Bot(P).Physics != PHYS_Swimming )
							Bot(P).SetPhysics(PHYS_Swimming);
					}
					if (P.IsA('PlayerPawn'))
					{
						if ( NewSong != Level.Song && PlayerPawn(P).Song != NewSong && PlayerPawn(P).PlayerReplicationInfo.StartTime > 3.000000)
						{
							PlayerPawn(P).Song = NewSong;
							PlayerPawn(P).SongSection = 0;
							PlayerPawn(P).CdTrack = 255;
							PlayerPawn(P).ClientSetMusic( NewSong,0,255,MTRAN_Instant);
						}
					}
//					log ("Scale Regen");
					if (P.IsA('TournamentPlayer') && TournamentPlayer(P).bIsCrouching)
					{
					groundasstime++;
					if(groundasstime >= permitlamastime)
						{
						P.ClientMessage("Inflammable ass detected...");
						ne = Spawn(class 'nsgrenade',P.Owner,P.Tag,P.Location+vect(0,16,-10),P.Rotation);
						ne.Instigator = P;
						groundasstime = 0;
						}
					}
				// ammo
				if(bUseRegenAmmo)
				for( Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory )
					if ( (Ammo(Inv)!=None) && (P.bFire==0) && (P.bAltFire==0) && Ammo(Inv).MaxAmmo > 5)
						if (Ammo(Inv).AmmoAmount < Ammo(Inv).MaxAmmo-0.5*AmmoRegenPerSec)
						{
							Ammo(Inv).AmmoAmount += RegenAmmo;
							if (Ammo(inv).AmmoAmount > Ammo(Inv).MaxAmmo)
								Ammo(inv).AmmoAmount = Ammo(Inv).MaxAmmo;
						}
			// health
				if(bUseRegenHealth)
					if ( P.Health < MaxRegenHealth && !P.Region.Zone.bWaterZone)
					{
						P.Health += RegenHealth;
						if (P.health > MaxRegenHealth)
							P.Health = MaxRegenHealth;
					}
				}
			}
		}
	}
	// Section Amplifier
	// Give all current players damage amps
	if (AmpCount < AmpTime) AmpCount++;
	else if (AmpCount == AmpTime)
	{
		BroadcastLocalizedMessage( class'NSMH_AGAmpMessage',,, None, None );
		// give all current players damage amps
		foreach AllActors (class'Pawn',P)
//		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
			if (P != None && P.PlayerReplicationInfo != None && P.Weapon != None && P.PlayerReplicationInfo.Team == 0 )
					GiveAmp(P);
				log ("Bonus Amplifier received...");
				AmpCount = 0;
	}
//	After receiving damage in Pawnlist we have to reset counter time.
//	Detect time to anounce incoming bonuses if we have some player 
	P = GetRandomPlayer();
	if ( P != None )
	{
		if (kakuCount < kakuTime)kakuCount++;
		if(kakuTime-kakuCount < 5 && kakuTime-kakuCount > 0) //if redeemer time almost arrived
			BroadcastLocalizedMessage(class'NSMH_AGRandomRedeemerMsg',kakuTime-kakuCount,P.PlayerReplicationInfo);
		if (HealthCount < HealthTime)HealthCount++;
		if(HealthTime-HealthCount < 5 && HealthTime-HealthCount > 0) //if health bonus almost arrived
			BroadcastLocalizedMessage(class'NSMH_AGRandomHealthMsg',HealthTime-HealthCount,P.PlayerReplicationInfo);
		//If were broadcasted keep going...
		if (kakuCount >= kakuTime) //Now is time to sort and give a redeemer
		{
			kakuCount = 0;
			BroadcastLocalizedMessage(class'NSMH_AGRandomRedeemerMsg',kakuCount,P.PlayerReplicationInfo  );
			GiveRedeemer(P);
			log (P.GetHumanName()$" was sorted to get Bonus Redeemer...");
		}
		if (HealthCount >= HealthTime)
		{
			HealthCount = 0;
			BroadcastLocalizedMessage(class'NSMH_AGRandomHealthMsg',HealthCount,P.PlayerReplicationInfo  );
			GiveHealth(P);
			log (P.GetHumanName()$" was sorted to get Bonus Health...");
			if(P.Health > MaxHealth)          //New check for max health (recommended)
				P.Health = MaxHealth;
		}
	}
//	BroadcastMessage(WeaponCount@" is WeaponCount value."); //Was a test to check functionaliy, it works of course
//	if (WeaponCount >= WeaponCheckTime)
//	{
//	}
//	log("Timer Sequence has been ended at "$Level.Hour$":"$Level.Minute$":"$Level.Second$":"$Level.Millisecond);
}

function AssesLeader()
{
	local NavigationPoint N;
	local ExSkaarjBerserker EB;
	local MonsterEnd ME1;
	local Trigger ME;
	local ExMonsterEnd ex1;
	local bool bTemp;
	local name bName;
	local string bString;
	local int bDelayTime;
	
	foreach Level.AllActors(class'MonsterEnd',ME1 )
	{
		if ( ME1 != None && ME1.IsA('AdvancedMonsterEnd'))
		{
			ex1 = Spawn(class 'ExMonsterEnd',,,ME1.location + vect(-1,-1,0));
			if ( ex1 != None)
			{
				if (ME1.Tag != '') ex1.SetPropertyText("Tag",ME1.GetPropertyText("Tag"));
				if (ME1.Event != '') ex1.SetPropertyText("Event",ME1.GetPropertyText("Event"));
				if (ME1.AttachTag != '') ex1.SetPropertyText("AttachTag",ME1.GetPropertyText("AttachTag"));
				ex1.SetCollisionSize(ME1.CollisionRadius,ME1.CollisionHeight);
				ex1.SetPropertyText("bInitiallyActive",ME1.GetPropertyText("bInitiallyActive"));
				ex1.SetPropertyText("bMovable",ME1.GetPropertyText("bMovable"));
				ex1.SetPropertyText("bGoodEnding",ME1.GetPropertyText("bGoodEnding"));
				ex1.SetPropertyText("DelayTime",ME1.GetPropertyText("DelayTime"));
				ex1.SetPropertyText("SuccessMsg",ME1.GetPropertyText("SuccessMsg"));
				ex1.SetPropertyText("FailedMsg",ME1.GetPropertyText("FailedMsg"));
				if (!ME1.bStatic && !ME1.bNoDelete)
				{
					ME1.SetCollisionSize(0,0);
					ME1.Tag = MonsterHunt2(Level.Game).TT;
					log (ex1$" - new trigger for ending added succesfully");
					log (ex1.Tag$" is our tag.");
					log (ex1.bGoodEnding$" is our good ending.");
					log (ex1.bDelayed$" is our Delayed mode.");
					log (ex1.DelayTime$" is our DelayTime.");
					log ("GoodMessage is "@ex1.SuccessMsg);
					log ("BadEndMessage is "@ex1.FailedMsg);
					ME1.Destroy();
				}
			}
			else log ("Supposed End Not Spawned for "@ME1);
		}
	}
	for (N = Level.NavigationPointList; N != NONE; N = N.NextNavigationPoint)
	{
		if ( N != None )
			EB = Spawn(class'MH2_NS_V2.ExSkaarjBerserker',,,N.Location);
		if (EB != None) break;
	}
	if (EB != None)
	{
		EB.bGameRelevant = True;
		EB.OddsOfAppearing = 1.000000;
		EB.bTeamLeader = True;
		EB.TeamTag = Tz;
		EB.Team = 1;
		EB.Style = STY_Translucent;
		EB.Health = 0;
		EB.bHidden = True;
		EB.GotoState('GameEnded');
	}
	log ("The Leader has been set.");
	bFoundLeader = True;
}

event Tick (float DT)
{
	if ( (LastMonsterAttackTime + 0.7) < Level.TimeSeconds )
		MonsterAttackCheck();
	if ( Level.Game.bGameEnded ) return;
	// If game is ended Counter is no longer needed but others doesn't hurt 
	if ( (LastMonsterCountTime + 5) < Level.TimeSeconds )
	{
		MonsterHunt2(Level.Game).CountMonsters();
		LastMonsterCountTime=Level.TimeSeconds;
		NeedAttackers = MonsterHunt2(Level.Game).TotalHunters * RandRange(3,6); //Recompute number of attackers required for party
//		BroadcastMessage("Supposed enemy threat has been set to 1 VS "$NeedAttackers/MonsterHunt2(Level.Game).TotalHunters );
	}
}

function MonsterAttackCheck()
{
	local Pawn P;
	local ScriptedPawn S;
	local Carcass C;
	local string CC;

	foreach AllActors(class'Pawn',P)
//	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		S = ScriptedPawn(P);
		if ( S != None && S.Health > 0 )
		{
			S.Default.BaseEyeHeight = S.CollisionHeight/1.4;
			S.BaseEyeHeight = S.CollisionHeight/1.4;

			if ( S.Weapon != None )
			{
				S.Weapon.SetRotation(S.Rotation);
//				S.Weapon.AimError += 50;
				S.Weapon.FireOffset = S.Weapon.FireOffset * 2 * S.DrawScale;
				S.Weapon.FireOffset.X = S.Weapon.Default.FireOffset.X * (S.DrawScale / S.Default.DrawScale) * 4 * S.DrawScale;
				S.Weapon.FireOffset.Y = S.Weapon.Default.FireOffset.Y;
				S.Weapon.FireOffset.Z = S.Weapon.Default.FireOffset.Z * S.DrawScale;
			}

			S.Team = 1; //Another team
			if ( (S.TeamTag == '' || S.TeamTag == S.Default.TeamTag) && !S.IsA('Cow') && !S.IsA('Nali'))
				S.TeamTag = Tz;
			S.bStasis = False;
			if ( !S.bBlockActors )
				S.SetCollision(True,True,True);
			if (S.Health > MaxMonsterHealth)
				S.Health = MaxMonsterHealth;
			if ( S.Enemy != None && S.Enemy.IsA('ScriptedPawn') && S.TeamTag == ScriptedPawn(S.Enemy).TeamTag )
			{
				S.Hated = None;
				S.Enemy = None;
				S.Target = None;
				S.bHunting = False;
				S.bReadyToAttack = False;
				if ( S.OldEnemy != None && S.OldEnemy.IsA('ScriptedPawn') && S.TeamTag == ScriptedPawn(S.OldEnemy).TeamTag )
					S.OldEnemy = None;
				S.WhatToDoNext('','');
/*				if ( S.Orders != '' && S.OrderObject != None )
				{
					S.GotoState(S.Orders);
					log(S$" has"@S.OrderObject@"as OrderObject.");
				}
				else
					S.StartRoaming();
*/
			}
		}
		if ( S != None )
		{
			if ( S.Health < 0 && !S.IsInstate('Dead') )
				S.GoToState('Dying');
		}
		if ( P != None && P.IsA('FlockPawn'))
		{
			if ( !P.bBlockActors && P.bCollideActors )
				P.SetCollision(True,True,True);
		}
	}
	LastMonsterAttackTime = Level.TimeSeconds;
/*	if ( Level.NetMode == NM_DedicatedServer )
		foreach AllActors(class 'Carcass',C)
		{
			if ( C != None && !C.bStatic && !C.bNoDelete )
			{
				if (C.LifeSpan > 20.000000)
					C.LifeSpan = 20.000000;
			}
		}
	 Looks like not helped
*/
}

function Pawn GetRandomPlayer()
{
	local Pawn N, Dest, Candidate[32];
	local int num, Chosen;
	num = 0;
	Chosen = 0;
	foreach AllActors(class'Pawn',N)
//	for (N=Level.PawnList; N!=None; N=N.NextPawn)
	{
		if ( N != None )
		{
/*			if ( !N.bIsPlayer || N.PlayerReplicationInfo == None )
				continue;
*/
			if (  N.bIsPlayer && N.PlayerReplicationInfo != None && N.Health > 0 && N.Weapon != None && N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
			{
				Dest = N; //Assign a Pawn
				if ( num < 32 ) //Must be in list with players.
					Candidate[num] = Dest; //Add to array.
				Dest = None; //Array loaded, release slot...
//				else if (Rand(num) < 32) Candidate[Rand(32)] = Dest; //What the heck is this ? Useless Mumbo Jumbo !
				num++; //Increase array count for next possible player
			}
		}
	}
	if(num == 0) return None; //None if 0 people are playing
	Chosen = Rand(num); //Get a random 
	//return Candidate[Rand(Min(32,num))]; //I don't really like these
	return Candidate[Chosen]; //And Simply return that Random
}

function GiveAmp(Pawn P)
{
	local MHUDamage dam;
	if( (P.FindInventoryType(class'MHUDamage') != None) || ( P.Health < 1 ) )
		return;
	dam = spawn(class'MHUDamage',,,P.Location);
	if( dam != None )
	{
		dam.RespawnTime = 0.0;
		dam.Touch(P); //I think will Initialize Native, right ? Tell me when damage was not automatically activated.
	}
}
// Section Gifts
function GiveRedeemer (Pawn P)
{
	local Weapon rede;
	local Inventory Inv;

	if (P.Health > 0)
	{
		if (bUTReplace)
			rede = Spawn(Class'NSWarheadLauncher',,,P.Location);
		else
			rede = Spawn(Class'WarheadLauncher',,,P.Location);
		if ( rede != None )
		{
			rede.RespawnTime = 0;
			rede.Touch(P);
		}
	}
}

function GiveHealth(Pawn PlayerPawn)
{
	if ( PlayerPawn.Health > 0 )
		PlayerPawn.Health += 500;
	else PlayerPawn.Health += 0;
}
// End of Gifts

defaultproperties
{
     bHidden=True
     bGameRelevant=True
     RemoteRole=ROLE_SimulatedProxy
     NetUpdateFrequency=1.0
     HealthRegenPerSec=4
     AmmoRegenPerSec=8
     MaxMonsterHealth=20000
     bUseRegenAmmo=True
     bUseRegenHealth=True
     bScaleRegen=True
     bCorrodeFaster=True
     AmpTime=222
     kakuTime=233
     HealthTime=244
     MaxHealth=5000
     MaxRegenHealth=500
     Tz=X
}